// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyssldigest.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for creating message digests.
** 
*****************************************************************************/

#ifndef FANCYSSL_DIGEST_H
#define FANCYSSL_DIGEST_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct env_md_ctx_st;
  typedef struct env_md_ctx_st EVP_MD_CTX;
};

namespace Fancy {
  namespace SSL {
    class Digest : public Base
    {
    public:
      Digest ();
      Digest (const Digest &a);

      ~Digest();

      Digest &operator= (const Digest &a);

      void setMDAlgo(const char *name);
      
      bool isValid() const;

      void addMessage(const char *m, int len=-1);
      void addFd(int fd, const char *filename);
      void addFile(const char *filename);

      std::string getDigest() const;

    private:
      EVP_MD_CTX *ctx;
    };
  }
}

#endif
