// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslexception.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Base functionality for OpenSSL integration.
** 
*****************************************************************************/

#ifndef XMLSSL_EXCEPTION_H
#define XMLSSL_EXCEPTION_H

#include <fancyexception.h>

namespace  Fancy {
  namespace SSL {

    class Exception : public Fancy::Exception
    {
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      ~Exception() throw();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority) throw();

    };

    class CException : public Fancy::CException
    {
    public:
      CException (int facility,
                  int priority,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      CException (int facility,
                  int priority,
                  int _errno,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,5,6)))
#endif
        ;

      ~CException() throw();

    protected:
    };

    class SSLException : public Exception
    {
    public:
      SSLException (int facility,
                    int priority,
                    const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      ~SSLException() throw();
    };

  }
}

#endif
