// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyssllog.h 55 2007-01-30 11:10:55Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
** 
*****************************************************************************/

#ifndef FANCYSSL_LOG_H
#define FANCYSSL_LOG_H

#include <fancylog.h>

  // facility masks.
#define  FANCYSSL_LOG_BASE     (1<<0)
#define  FANCYSSL_LOG_PKEY     (1<<1)
#define  FANCYSSL_LOG_X509     (1<<2)
#define  FANCYSSL_LOG_PKCS7    (1<<3)
#define  FANCYSSL_LOG_SOCK     (1<<4)
#define  FANCYSSL_LOG_DIGEST   (1<<5)

namespace Fancy {
  namespace SSL {

    extern fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    void fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));
    
#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
  }
}

#endif // ! FANCYSSL_LOG_H
