// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslpkey.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for handling OpenSSL private keys.
** 
*****************************************************************************/

#ifndef FANCYSSL_PKEY_H
#define FANCYSSL_PKEY_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct evp_pkey_st;
  typedef struct evp_pkey_st EVP_PKEY;
};

namespace Fancy {
  namespace SSL {

    class PKey : public Base
    {
    public:
      PKey ();
      PKey (const PKey &a);
      PKey (EVP_PKEY *k);

      ~PKey();

      PKey &operator= (const PKey &a);

      EVP_PKEY *getPKEY () const;

      void readFile(const char *file);

      void setPEMString(const char *passwd, const char *pem, int len=-1);

      void generate();

      bool isValid() const;

      std::string getPEMString(const char *passwd) const;

    private:
      EVP_PKEY *pkey;
    };
  }
}

#endif
