// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslx509cert.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for handling OpenSSL X509 Certificates.
** 
*****************************************************************************/

#ifndef FANCYSSL_X509CERT_H
#define FANCYSSL_X509CERT_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct x509_st;
  typedef struct x509_st X509;
};

namespace Fancy {
  namespace SSL {
    class X509Name;

    class X509Cert : public Base
    {
    public:
      X509Cert ();
      X509Cert (const X509Cert &a);
      X509Cert (X509 *_x509);

      ~X509Cert();

      X509Cert &operator= (const X509Cert &a);

      bool operator == (const X509Cert &a) const;
      bool operator != (const X509Cert &a) const;
      bool compare (X509 *a) const;

      X509 *getX509 () const;

      void readFile(const char *file);

      std::string getPEMString() const;
      void setPEMString(const char *pem, int len=-1);

      bool isValid() const;

      X509Name getSubjectDN () const;
      X509Name getIssuerDN () const;
      std::string getSerial () const;

    private:
      X509 *x509;
    };
  }
}

#endif
