// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslx509crl.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for handling OpenSSL X509 CRLs.
** 
*****************************************************************************/

#ifndef FANCYSSL_X509CRL_H
#define FANCYSSL_X509CRL_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct X509_crl_st;
  typedef struct X509_crl_st X509_CRL;
};

namespace Fancy {
  namespace SSL {

    class X509Crl : public Base
    {
    public:
      X509Crl ();
      X509Crl (const X509Crl &a);
      X509Crl (X509_CRL *_x509_crl);

      ~X509Crl();

      X509Crl &operator= (const X509Crl &a);

      bool isValid() const;

      X509_CRL *getX509_CRL () const;

      void readFile(const char *file);

      std::string getPEMString() const;
      void setPEMString(const char *pem, int len=-1);

    private:
      X509_CRL *x509_crl;
    };
  }
}

#endif
