// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslx509name.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for handling OpenSSL X509 DNs.
** 
*****************************************************************************/

#ifndef FANCYSSL_X509NAME_H
#define FANCYSSL_X509NAME_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct X509_name_st;
  typedef struct X509_name_st X509_NAME;
};

namespace Fancy {
  namespace SSL {
    class X509Name : public Base
    {
    public:
      X509Name ();
      X509Name (const X509Name &a);
      X509Name (X509_NAME *_x509_name);

      ~X509Name();

      X509Name &operator= (const X509Name &a);

      X509_NAME *getX509_NAME () const;
      X509_NAME *dup () const;

      void addDNcomponent(const char *comp, const unsigned char *utf8);

      std::string getDNComponentUtf8(const char *comp) const;
      std::string getOneLine() const;
      std::string getRFC2253() const;

    private:
      X509_NAME *x509_name;
    };
  }
}

#endif
