// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysslx509req.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A class for handling OpenSSL X509 requests (PKCS10).
** 
*****************************************************************************/

#ifndef FANCYSSL_X509REQ_H
#define FANCYSSL_X509REQ_H

#include <fancysslbase.h>

// fwd decls from openssl.
extern "C" {
  struct X509_req_st;
  typedef struct X509_req_st X509_REQ;
};

namespace Fancy {
  namespace SSL {
    class X509Name;
    class PKey;

    class X509Req : public Base
    {
    public:
      X509Req ();
      X509Req (const X509Req &a);
      X509Req (X509_REQ *_x509_req);

      ~X509Req();

      X509Req &operator= (const X509Req &a);

      bool isValid() const;

      X509_REQ *getX509_REQ () const;

      void generate(const X509Name &dn, const PKey &key);

      std::string getPEMString() const;

    private:
      X509_REQ *x509_req;
    };
  }
}

#endif
